Package org.bukkit.block

# Interface CommandBlock

All Superinterfaces:
  `BlockState`, `CommandBlockHolder`, `Metadatable`, `PersistentDataHolder`, `TileState`

public interface CommandBlock extends TileState, CommandBlockHolder
Represents a captured state of a command block.

## Method Summary

Modifier and Type
Method
Description
`@NotNull String`
`getCommand()`
Gets the command that this CommandBlock will run when powered.
`@NotNull String`
`getName()`
Deprecated.
in favour of `name()`
`Component`
`name()`
Gets the name of this CommandBlock.
`void`
`name(Component name)`
Sets the name of this CommandBlock.
`void`
`setCommand(@Nullable String command)`
Sets the command that this CommandBlock will run when powered.
`void`
`setName(@Nullable String name)`
Deprecated.
in favour of `name(net.kyori.adventure.text.Component)`

### Methods inherited from interface org.bukkit.block.BlockState

`getBlock, getBlockData, getChunk, getData, getDrops, getDrops, getDrops, getLightLevel, getLocation, getLocation, getRawData, getType, getWorld, getX, getY, getZ, isCollidable, isPlaced, setBlockData, setData, setRawData, setType, update, update, update`

### Methods inherited from interface io.papermc.paper.command.CommandBlockHolder

`getSuccessCount, lastOutput, lastOutput, setSuccessCount`

### Methods inherited from interface org.bukkit.metadata.Metadatable

`getMetadata, hasMetadata, removeMetadata, setMetadata`

### Methods inherited from interface org.bukkit.block.TileState

`getPersistentDataContainer, isSnapshot`

## Method Details

### getCommand

@NotNull @NotNull String getCommand()
Gets the command that this CommandBlock will run when powered. This will never return null. If the CommandBlock does not have a command, an empty String will be returned instead.

Specified by:
  `getCommand` in interface `CommandBlockHolder`
Returns:
  Command that this CommandBlock will run when powered.

### setCommand

void setCommand(@Nullable @Nullable String command)
Sets the command that this CommandBlock will run when powered. Setting the command to null is the same as setting it to an empty String.

Specified by:
  `setCommand` in interface `CommandBlockHolder`
Parameters:
  `command` - Command that this CommandBlock will run when powered.

### getName

@Deprecated @NotNull @NotNull String getName()
Deprecated.
in favour of `name()`
Gets the name of this CommandBlock. The name is used with commands that this CommandBlock executes. This name will never be null, and by default is "@".

Returns:
  Name of this CommandBlock.

### setName

@Deprecated void setName(@Nullable @Nullable String name)
Deprecated.
in favour of `name(net.kyori.adventure.text.Component)`
Sets the name of this CommandBlock. The name is used with commands that this CommandBlock executes. Setting the name to null is the same as setting it to "@".

Parameters:
  `name` - New name for this CommandBlock.

### name

@NotNull Component name()
Gets the name of this CommandBlock. The name is used with commands that this CommandBlock executes. This name will never be null, and by default is a `TextComponent` containing `@`.

Returns:
  Name of this CommandBlock.

### name

void name(@Nullable Component name)
Sets the name of this CommandBlock. The name is used with commands that this CommandBlock executes. Setting the name to null is the same as setting it to a `TextComponent` containing `@`.

Parameters:
  `name` - New name for this CommandBlock.